
local Healcsi = Healcsi
local Gui     = Healcsi.Gui
local Modules = Healcsi.Modules

function Healcsi:RegisterModulesToDropdown()
	-- silly thing but we need to give it an empty table first...
	self.configWindow.menu.modules.selector:SetList({})

	-- Register modules to the dropdown:
	for _, mod in pairs(Healcsi.Modules) do
		self.configWindow.menu.modules.selector:AddItem(mod.key, mod.name)
	end
end

local function ShowModule(value)
	local found = false
	for key, editor in pairs(Healcsi.configWindow.modulesEditor.editors) do
		if (key == value) then
			editor.frame:Show()

			found = true

			if (Healcsi.Modules[key].RefreshData) then -- no longer implemented... ;(
				Healcsi.Modules[key]:RefreshData()
			end
			
			-- This is where I implemented the layout... dumb? yes! works? yes ;) do I care? no :)
			editor.frame:ClearAllPoints()
			editor.frame:SetPoint("TOPLEFT", Healcsi.configWindow.modulesEditor.content)
			editor.frame:SetPoint("BOTTOMRIGHT", Healcsi.configWindow.modulesEditor.content)

			if (Healcsi.Modules[key].RefreshScrollBar) then
				Healcsi.Modules[key]:RefreshScrollBar() -- OMG, set the scrollbar correctly pretty ples
			end
		else
			editor.frame:Hide()
			
		end
	end
	if (found) then
		Healcsi.db.global.configWindow.selectedModule = value
	else
		Healcsi.db.global.configWindow.selectedModule = ""
	end
end

local function ModuleSelectorChanged(self, event, value)
	if (event == "OnValueChanged") then
		ShowModule(value)
	end
end

function Healcsi:ModuleSelectorInit()
	self:RegisterModulesToDropdown()
	self.configWindow.menu.modules.selector:SetCallback("OnValueChanged", ModuleSelectorChanged)
	self.configWindow.menu.modules.selector:SetValue(Healcsi.db.global.configWindow.selectedModule)
	ShowModule(Healcsi.db.global.configWindow.selectedModule)
end

function Healcsi:CreateModulesEditor()

	local container = Gui:Create("SimpleGroup")
	container:SetLayout("Flow")
	container:SetFullWidth(true)
	container:SetFullHeight(true)

	-- we will implement our own Layout cause the default always wants to call :Show() on all child elements
	container:PauseLayout()

	container.editors = {}

	for _, mod in pairs(Healcsi.Modules) do
		local frame = mod:CreateEditor()
		frame.frame:Hide()

		container:AddChild(frame)
		container.editors[mod.key] = frame
	end

	return container
end
