
local Healcsi       = Healcsi
local Console       = Healcsi.Console
local Media         = Healcsi.Media
local Gui           = Healcsi.Gui
local L             = Healcsi.Locale
local Modules       = Healcsi.Modules
local Editor        = Healcsi.Editor
local ToolBox       = Healcsi.Modules.ToolBox
local UnitButtons   = Healcsi.Modules.UnitButtons
local UnitFrames    = Healcsi.Modules.UnitFrames

local IsRaidMarkerActive = IsRaidMarkerActive


local function IsAllowed()
	local group, leadship, num = UnitFrames:GetGroupStats() 
	if group == "raid" then
		return leadship == "leader" or leadship == "officer"
	else
		return 1
	end
end

function ToolBox:CreateWorldMarks()
	local frame = self:CreateToolbox("HealcsiToolboxWorldMarks", 0, 1, 0, L["WorldMarks"], L["WorldMarksToolBoxTooltip"])
	RegisterStateDriver(frame, "visibility", "[group] show; hide")

	local menu = frame:CreateMenu(L["WorldMarks"])

	local function Button_OnClick(self)
		if not IsAllowed() then
			ToolBox:PrintPermissionError()
		end
	end

	local function Button_OnUpdate(self)
		if IsRaidMarkerActive(self:GetID()) then
			self.check:Show()
		else
			self.check:Hide()
		end
	end

	local NUM_BUTTONS = NUM_WORLD_RAID_MARKERS + 1

	local i
	for i = 1, NUM_BUTTONS do
		local button = menu:AddButton(i == NUM_BUTTONS and REMOVE_WORLD_MARKERS or _G["WORLD_MARKER"..i], "SecureActionButtonTemplate")
		button:SetID(i)
		button:HookScript("OnClick", Button_OnClick)
		button:SetAttribute("type", "worldmarker")
		if i == NUM_BUTTONS then
			button:SetAttribute("action", "clear")
		else
			button:SetAttribute("marker", i)
			button:SetScript("OnUpdate", Button_OnUpdate)
		end

	end

	menu:Finish()
end

