local Healcsi    = Healcsi
local Console    = Healcsi.Console
local Media      = Healcsi.Media
local Gui        = Healcsi.Gui
local L          = Healcsi.Locale
local Modules    = Healcsi.Modules

Modules.UnitAuras = {
	name = "Unit Auras",
	id = 4,
	key = "UnitAuras",
	initDone = false,

	defaults = {
		selectedTab = "buffs",
		debuffHighlight = {
			customDebuffs = {},
			userLevels = {},
			scale = 1.5,
			anchor = "CENTER",
			offset = {
				x = 0,
				y = 0
			},
			alpha = 0.8,
			show = true,
			zoom = 0.08,
			lastTierSelected = 7, -- Legion
			lastInstanceSelected = nil,
			lastBossSelected = nil
		},
		buff = {
			show = true,
			anchor = "BOTTOMLEFT",
			grow = "LEFT",
			offset = {
				x = 0,
				y = 0
			},
			size = 16,
			zoom = 0.1,
			alpha = 0.8,
			count = 6,
			availableWidth = 1,
			availableHeight = 0.35,
			demo = false,
			stack = {
				anchor = "TOPLEFT",
					offset = {
					x = -2,
					y = 4
				},
				font = "Impact",
				size = 10,
				hasOutline = true
			},
			remaining = {
				anchor = "BOTTOMRIGHT",
					offset = {
					x = 5,
					y = -3
				},
				font = "Collegiate",
				size = 10,
				hasOutline = true,
				alpha = 0.6
			},
			check = {
				before = {
					{class="PRIEST", spellId=81749},  -- Atonement
					{class="PRIEST", spellId=77489},  -- Echo-of-Light
					{class="PRIEST", spellId=33076},  -- Prayer-of-Mending
					{class="PRIEST", spellId=64843},  -- Divine-hymn

					{class="SHAMAN", spellId=207360}, -- Queen-s-Decree

					{class="MONK", spellId=115151}, -- Renewing-mist
					{class="MONK", spellId=191840}, -- Essence-font
					{class="MONK", spellId=193884}, -- Soothing-mist
					{class="MONK", spellId=199665}, -- Blessing-of-Yu'lon

					{class="PALADIN", spellId=642}, -- Divine-Shield
					{class="PALADIN", spellId=498}, -- Divine-Protection

					{class="DRUID", spellId=207385}, -- Spring-Blossoms
					{class="DRUID", spellId=155777} -- Rejuvenation-(Germination)
				},
				after = {
					{class="SHAMAN", spellId=207400}, -- Ancestral-Vigor
					{class="ALL",    spellId=242622}, -- Healer trinket
				}
			}
		},
		debuff = {
			show = true,
			anchor = "TOPRIGHT",
			grow = "RIGHT",
			offset = {
				x = 0,
				y = 0
			},
			onlyDispellable = false,
			size = 20,
			zoom = 0.1,
			alpha = 0.8,
			count = 5,
			availableWidth = 1,
			availableHeight = 0.45,
			demo = false,
			stack = {
				anchor = "TOPLEFT",
					offset = {
					x = -2,
					y = 4
				},
				font = "Impact",
				size = 11,
				hasOutline = true
			},
			remaining = {
				anchor = "BOTTOMRIGHT",
					offset = {
					x = 5,
					y = -3
				},
				font = "Collegiate",
				size = 11,
				hasOutline = true,
				alpha = 0.6
			}
		},
		dispel = {
			show = true,
			width = 8,
			flash = {
				enable = true,
				speed = 2, -- 1 - 5
				alpha = 0.8
			}
		}
		-- , ...
	}
}

--[[
Required method:

function ClickCast:Initialize()
	...
	self.initDone = true
end

of which must set the UnitFrames.initDone variable to true when it's finished successfully.


Required method for config:

function ClickCast:CreateEditor()
	CreateFrame
	...
	frame:addChild(xy)
	...
	frame:AddChildren(f1, f2, f3)
	...
	return frame
end

]]
