
local Healcsi    = Healcsi
local Console    = Healcsi.Console
local Media      = Healcsi.Media
local Gui        = Healcsi.Gui
local L          = Healcsi.Locale
local Modules    = Healcsi.Modules
local UnitFrames = Healcsi.Modules.UnitFrames

Modules.UnitFrames = {
	name = "Unit Frames",
	id = 2, -- Module 'UnitButtons' is a prerequisite! Let's load it after that...
	key = "UnitFrames",
	initDone = false,

	defaults = {
		general = {
			lockPosition = false,
			alignHorizontally = true
		},
		solo = {
			showWhenNotGrouped = true
		},
		party = {
			showWhenInParty = true,
			showPartyPets = true,
			hideBlizzPartyFrames = true
		},
		raid = {
			showWhenInRaid = true,
			showRaidPets = true,
			keepGroupsTogether = true,
			sortMethod = "group", -- class, role, name, group
			hideBlizzRaidFrames = true
		},
		friendly = {
			showFriendlyNPC = true
		},
		container = {
			showBackground = true,
			marginSize = 5,
			scale = 1.05,
			background = {
				color = {r=0/255, g=0/255, b=0/255, a=100/255},
				commonInset = true,
				insets = {top=6, right=6, bottom=6, left=6},
				tileSize = 16,
				tile = "stretch",
				file = "Solid",
			},
			border = {
				file = "Glow",
				edgeSize = 6,
				color = {r=0/255, g=0/255, b=0/255, a=150/255}
			},
			--updateInterval = 0.2, -- hardcoded
			offset = {
				top = 0,
				left = 0
			}
		}
	}
}

--[[
Required method:

function UnitFrames:Initialize()
	...
	self.initDone = true
end

of which must set the UnitFrames.initDone variable to true when it's finished successfully.


Required method for config:

function UnitFrames:CreateEditor()
	CreateFrame
	...
	frame:addChild(xy)
	...
	frame:AddChildren(f1, f2, f3)
	...
	return frame
end

]]
