local Healcsi     = Healcsi
local UnitFrames  = Healcsi.Modules.UnitFrames
local UnitButtons = Healcsi.Modules.UnitButtons
local Editor      = Healcsi.Editor

local RegisterStateDriver = RegisterStateDriver

function UnitFrames:Solo_UpdateLayout()
	if (not(self.Solo)) then self:Solo_CreateFrame() end

	local horiz, spacing = self:GetLayoutData()

	self.Solo.petButton:ClearAllPoints()
	if (horiz) then
		self.Solo.petButton:SetPoint("LEFT", self.Solo.playerButton, "RIGHT", spacing, 0)
	else
		self.Solo.petButton:SetPoint("TOP", self.Solo.playerButton, "BOTTOM", 0, -spacing)
	end
end

function UnitFrames:Solo_GetFramesMatrix()
	-- local self = UnitFrames
	if (not(self.Solo)) then self:Solo_CreateFrame() end

	local hasPet = self.Solo.petButton:IsVisible()
	local count = hasPet and 2 or 1

	if (self:GetAlignHoriz()) then
		return count, 1, hasPet
	else
		return 1, count, hasPet
	end
end

function UnitFrames:Solo_CreateFrame()
	local frame = self:Container_CreateGroupParent("HealcsiSoloFrame")
	RegisterStateDriver(frame, "visibility", "[group] hide; show")

	local playerButton = CreateFrame("Button", frame:GetName().."Player", frame, "HealcsiUnitButtonTemplate")
	playerButton:SetAttribute("unit", "player")
	playerButton:SetPoint("TOPLEFT")
	playerButton:Show()

	local petButton = CreateFrame("Button", frame:GetName().."Pet", frame, "HealcsiUnitButtonTemplate")
	RegisterStateDriver(petButton, "visibility", "[nopet] hide; [vehicleui] hide; show")
	petButton:SetAttribute("unit", "pet")

	self.Solo = {}
	self.Solo.frame        = frame
	self.Solo.playerButton = playerButton
	self.Solo.petButton    = petButton

	self:Solo_UpdateLayout()
end

Healcsi:RegisterEventCallback("UnitButtonConfigChanged", function()
	if (not(Editor.InCombat)) then
		UnitFrames:Solo_UpdateLayout()
	end
end)

Healcsi:RegisterEventCallback("UnitFrameConfigChanged", function()
	if (not(Editor.InCombat)) then
		UnitFrames:Solo_UpdateLayout()
	end
end)

Healcsi:RegisterEventCallback("GlobalConfigRefresh", function()
	if (not(Editor.InCombat)) then
		UnitFrames:Solo_UpdateLayout()
	end
end)